#!/bin/env python3
import sys
import math
import urllib.request

import prvni_ui
def cti_odpoved(lines):
    global id_hry, zbyva_tahu, plocha, lovec
    if lines[0][0:5]=="Konec" or lines[0][0:5]=="Chyba":
        return -1

    id_hry=lines[0]
    zbyva_tahu=math.ceil(int(lines[1])/2)
    plocha=lines[2:12] # nejdriv y, pak x - musi byt krat 2
    lovec=[int(x) for x in lines[12].split(" ")]
    return 0

def get(x,y):
    return plocha[y][x*2]

def add(x,y):
    global poc,q
    if x<0 or x>9 or y<0 or y>9:
        return
    if poc[x][y]==100000 and (get(x,y)!="X" and get(x,y)!="-"): # todo
        q.append((x,y))

def getsteps(x,y):
    global poc
    if x<0 or x>9 or y<0 or y>9:
        return 100000
    return poc[x][y]

def gettreasure(x,y):
    global plocha
    return int(plocha[y][x*2]+plocha[y][x*2+1])

server=sys.argv[1]

fh=urllib.request.urlopen(server+"/start")
lines=fh.read().decode("utf-8").split("\r\n")
tahu_celkem=lines[1]
cti_odpoved(lines)

def dfs(co):
    global poc,q
    poc=[[100000 for x in range(10)] for y in range(10)]

    q=[]
    for x in range(10):
        for y in range(10):
            if get(x,y)==co:
                t=(x,y)
                

    poc[t[0]][t[1]]=0

    add(t[0]-1,t[1])
    add(t[0]+1,t[1])
    add(t[0],t[1]-1)
    add(t[0],t[1]+1)

    while len(q)!=0:
        t=q.pop()
        poc[t[0]][t[1]]=min(getsteps(t[0]+1,t[1]),getsteps(t[0]-1,t[1]),getsteps(t[0],t[1]-1),getsteps(t[0],t[1]+1))+1

        if ord(get(t[0],t[1]))>=48 and ord(get(t[0],t[1]))<=57:
                continue # nepridavej sousedy pokladu, stejne se tam nedostanes

        add(t[0]-1,t[1])
        add(t[0]+1,t[1])
        add(t[0],t[1]-1)
        add(t[0],t[1]+1)

    return poc

while cti_odpoved(lines)!=-1:
    poc=[]
    q=[]
    pocsoup=dfs("-")
    dfs("+") # nechej v poc


    

    tre=[]
    for x in range(10):
        for y in range(10):
            if ord(get(x,y))>=48 and ord(get(x,y))<=57:
                tre.append((x,y,gettreasure(x,y)/poc[x][y]))

    tre.sort(key=(lambda t: t[2]), reverse=True)

    if len(tre)==0:
        break
    jdi=tre[0]
    for x in tre:
        if poc[x[0]][x[1]]*2<=int(zbyva_tahu) and poc[x[0]][x[1]]<pocsoup[x[0]][x[1]]:
            jdi=x
            break


    path=[(jdi[0], jdi[1])]
    while poc[path[-1][0]][path[-1][1]]!=0:
        temp=[]
        tp=path[-1]
        temp.append((tp[0]-1,tp[1],getsteps(tp[0]-1,tp[1])))
        temp.append((tp[0]+1,tp[1],getsteps(tp[0]+1,tp[1])))
        temp.append((tp[0],tp[1]-1,getsteps(tp[0],tp[1]-1)))
        temp.append((tp[0],tp[1]+1,getsteps(tp[0],tp[1]+1)))
        temp.sort(key=lambda a: a[2])
        dalsi=temp[0]
        for (x,y,z) in temp:
            if ord(get(x,y))>=48 and ord(get(x,y))<=57:
                continue
            dalsi=(x,y)
            break

        path.append((dalsi[0], dalsi[1]))


    path=list(reversed(path))+path[1:]

    for x in range(1,len(path)):
        a,b=path[x-1][0]-path[x][0],path[x-1][1]-path[x][1]
        if a==1:
            kam="L"
        if a==-1:
            kam="P"
        if b==1:
            kam="N"
        if b==-1:
            kam="D"
        fh=urllib.request.urlopen(server+"/tah?id="+id_hry+"&pohyb="+kam)
        lines=fh.read().decode("utf-8").split("\r\n")


while cti_odpoved(lines)!=-1:
     fh=urllib.request.urlopen(server+"/tah?id="+id_hry+"&pohyb=N")
     lines=fh.read().decode("utf-8").split("\r\n")


